<template>
  <v-container>
    <h1 class="display-1 my-3 font-weight-bold">
      Claim your rebate
    </h1>
    <div class="title accent--text">
      Get a Cash Rebate From Find Your Next Apartment<br>
      Find a Rental Apartment in Dallas, Houston, Austin, San Antonio. Start Here!
    </div>
    <div>
      <b>Get a Cash Rebate</b> From Find Your Next Apartment! To qualify, you
      must list Find Your Next Apartment on the guest card, lease application
      and lease. You will also need to list your Find Your Next Apartment name.
      If you have any questions, phone your leasing agent at 800.891.2311.
    </div>
    <v-card flat class="mt-4">
      <v-card-title class="text-center d-block font-weight-medium py-1">
        <v-sheet tile color="accent" class="py-3 mb-2 white--text">
          Complete the rebate form
        </v-sheet>
      </v-card-title>
      <v-card-text class="py-2">
        <v-form v-model="isValid">
          <v-row dense>
            <v-col cols="6">
              <v-text-field v-model="form.fynaName" outlined label="Your find your next apartment agent name*" />
            </v-col>
            <v-col cols="12">
              <label for="accept">I put find your next apartment on my lease application</label>
              <v-checkbox name="accept" outlined label="Yes" />
            </v-col>
            <v-col cols="12">
              <label for="accept">I have read and agree to all rules, <a class="accent--text" @click="$vuetify.goTo(terms)">disclaimers and restrictions</a></label>
              <v-checkbox name="accept" outlined label="Yes" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.firstName" outlined label="First Name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.lastName" outlined label="Last Name*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.email" outlined type="email" label="Email*" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.phone" outlined type="tel" label="Phone*" />
            </v-col>
            <v-col cols="12">
              <v-text-field v-model="form.apartment" outlined label="Apartment Property you're moving to*" />
            </v-col>
            <v-col cols="12" class="mb-5">
              <div>Move In Date</div>
              <v-date-picker
                v-model="form.date"
                :min="(new Date()).toISOString()"
                landscape
                color="accent"
                class="mt-4"
              />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.rentPrice" outlined type="number" min="1" label="Rent Price" />
            </v-col>
            <v-col cols="6">
              <v-text-field v-model="form.leaseTerm" outlined type="number" min="1" label="Lease Term (Months)" />
            </v-col>
            <v-col cols="12">
              <v-text-field v-model="form.leasingAgent" outlined label="Leasing Agent at your new apartment" />
            </v-col>
          </v-row>
        </v-form>
      </v-card-text>
      <v-card-actions class="flex-column py-0">
        <v-btn color="accent" :loading="sending" block depressed @click="send">
          Send
        </v-btn>
      </v-card-actions>
      <v-alert :value="showSent" prominednt type="success" class="display-1 px-5">
        Sent
      </v-alert>
    </v-card>

    <!-- eslint-disable-next-line vue/no-v-html -->
    <article ref="terms" class="my-4" v-html="data ? data.content : ''" />
  </v-container>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'

export default defineComponent({
  setup (_, { root }) {
    const data = ref(root.$store.getters.getConfiguration('claim-your-rebate'))
    const sending = ref(false)
    const showSent = ref(false)
    const terms = ref(null)
    const form = ref({
      firstName: '',
      lastName: '',
      email: '',
      phone: '',
      apartment: '',
      date: '',
      rentPrice: 1,
      leaseTerm: 1,
      fynaName: '',
      leasingAgent: ''
    })
    const send = async () => {
      sending.value = true
      await root.$axios.post('/messages', {
        ...form.value,
        type: 'rebate-form'
      })
      sending.value = false
      showSent.value = true
      setTimeout(() => {
        showSent.value = false
      }, 1500)
    }

    return {
      data,
      sending,
      isValid: ref(false),
      showSent,
      send,
      form,
      terms
    }
  }
})
</script>
